/*
 *  Released under the GNU GPL.  See http://www.gnu.org/licenses/gpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  DeSmet C is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundatation; either version 2 of the License, or any
 *  later version.
 *
 *  DeSmet C is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */
/* GEN.C   - pass 2 for c88 */
/*
 *  Modification history:
 *    William Couture    11/18/05   Reformat/cleanup/comments
 */

#include "pass2.h"
#include "nodes.h"
#include "inst86.h"

char nextpgm[77]="Z:ASM88 Z:CTEMP4     U00 O";
               /*           1111111111222222 */
               /* 01234567890123456789012345 */
               /*                  B <if BIG memory model> */
               /*                    M <if Intel .OBJ output> */
               /*         d: <drive letter if D option, else 2 spaces) */
               /*                           <objname.O> appended here */
               /*                       00 replaced by utilization percentage */
char perfect = 1;


main(argc,argv)
   int  argc,argv[];
   {
   int  ctype;

   if (argc < 2)
      {
      os("missing file name");
      real_exit(2);
      }
   initopt(argc,argv);  /* get cmdline arguments */
   init();  /* get ready to parse intermediate files */
   if (zopt)  /* if generating .O file directly */
      asm_init();
   while (1)
      {
      ctype = ctlbyte();  /* get control structure type */
#if DEBUG
      if (eopt) 
         {
         os("control = ");
         odbyte(ctype);
         olf();
         }
#endif
      switch (ctype)
         {
         case 0:  /* EOF */
            endit();  /* does not return */
            /* no break */
         case 1:  /* EXTERN -- we are declaring a variable */
            addext(0);  /* data declaration & initialiation */
            break;
         case 2:  /* FUNCTION -- parse a function tree & generate code */
            addfun();
            break;
         case 3:  /* FLUSH -- end of function, make sure clear node list */
            nodesin = 0;
            break;
         default:  /* Oops... */
            error("Bad Control File");
         }
      }
   }

init()
   {
   char i, j, k, *intname;

   nextlab = 1000;  /* count __n labels from 1000 */
   lastlab = 1969;  /* count _F  labels down from 1969 */
   intname = "A:CTEMP2";  /* nodes file from C88 */
   if (topt)  /* if temp drive given */
      *intname = topt;  /* use that */
   else
      intname += 2;  /* else skip "A:" */
   if ((treef = open(intname,0)) == -1)   /* cannot open tree nodes file */
      error("Cannot Open CTEMP2");
   intree = &treebuf[BUFSIZE];  /* intree = end of buffer, force reload */

   intname = "A:CTEMP1";  /* control info from C88 */
   if (topt)  /* if temp drive given */
      *intname = topt;  /* use that */
   else
      intname += 2;  /* else skip "A:" */
   if ((control = open(intname,0)) == -1)  /* cannot open CTEMP1 */
      error("Cannot Open CTEMP1");
   if (read(control,ctlbuf,BUFSIZE) == -1)  /* oops! */
      error("Cannot Read CTEMP1");
   inctl = ctlbuf;  /* init buf ptr */

   if (zopt == 0)  /* generating .A file */
      {
      if (eopt == 0)  /* if not Ve debugging info */
         {
         if ((output = creat(asmname)) == -1)
            {
            os("Cannot Create ");
            error(asmname);
            }
         inout = outbuf;  /* init buf ptr */
         }
      else
         {
         inout = 0;  /* null pointer */
         os(asmname);  /* write output name */
         olf();
         }
      }
   nextext = ext;
   numswit = -1;  /* no switches */
   k = 1;  /* bit value */
   for (i = 0; i <= 11; i++)
      {
      regat[i] = 0;
      regpat[i] = k;  /* note that, since regpat[] is a BYTE, this is 0 for
                       * indices > 7 (the segment registers)
                       */
      k += k;
      }
   for (i = 0; i < 9; i++) /* relationship between vtype[VVAR] and used reg */
      regused[i] = 8;
   regused[2] =
   regused[4] = SI;
   regused[3] =
   regused[5] = DI;
   regused[7] = BX;

   /* initilize the names of the builtin functions. */

   initst(bltname,     "_SWITCH _CMP4 _SHR4 _SHL4 _MUL4 _DIV4 _MOD4 ");
   initst(&bltname[7], "_FLOADD _FLOADE _FLOADL _FSTORED _FSTOREE ");
   initst(&bltname[12],"_FSTOREL _FADD _FSUB _FMUL _FDIV _FCMP _FNEG ");
   initst(&bltname[19],"_FIS _FNOT _FDEC _FINC _FPUSH _FXCH _FCLEAR ");
   initst(&bltname[26],"_MOVE_ ");

#if DEBUG
   initch(namet,     "CHAR  INT   UNSG  LONG  LABEL STRUCTBITS  ");
      /* names of data types (6 chars each) */
   initch(&namen[0], "OPND  CONST LAB   CAST  TA    IND   IFE   WHIL  ");
   initch(&namen[8], "DOW   SWIT  FORS  RET   GOTOS CONT  BRK   LST2  ");
   initch(&namen[16],"LST3  LST4  LST5  LST6  CAS   DFLT  CALL  TEST  ");
   initch(&namen[24],"ADD   SUB   MUL   DIV   MOD   SHR   SHL   AND   ");
   initch(&namen[32],"OR    XOR   LOR   LAND  EQ    NE    GE    LT    ");
   initch(&namen[40],"GT    LE    NEG   NOT   COMP  PREI  PRED  POSTI ");
   initch(&namen[48],"POSTD ASGN  AADD  ASUB  AMUL  ADIV  AMOD  ASHR  ");
   initch(&namen[56],"ASHL  AAND  AOR   AXOR  NULL  ASM   STMT  MOVE  ");
     /* names of operands (6 chars each).  See NODES.H for more info */
#endif

   initst(jumps,"JNZ JZ JL JGE JLE JG JB JAE JBE JA JMP ");
      /* initialize JMP names */

   /* initialize register names */
   initst(regname,"AX CX DX BX SP BP SI DI ES DS SS CS ");
   initst(reglow,"AL CL DL BL ");
   initst(reghigh,"AH CH DH BH ");

/* operator types

    0   operand,  CAST, TA, IND
    1   statement
    2   function call
    3   test
    4   arithmetic
    5   shift
    6   binary
    7   logical
    8   comparison
    9   unary
   10   pre ++ or --
   11   post ++ or --
   12   assignment
   13   null
   14   list
   15   line number node
   16   structure assignment
*/

   initnum(optype,"001000111111111EEEEE112344444");
   initnum(subn  ,"00111132224110023456112322222");
   initnum(commut,"00000000000000000000000010100");

   initnum(&optype[29],"5566677888888999AABBCCCCCCCCCCCD1FG");
   initnum(&subn[29],  "22222222222221111111222222222220012");
   initnum(&commut[29],"00111001111110000000000000000000000");

#ifdef NEVERDEF
** /* another way of initalizing optype[], subn[], and commut[], this makes
**  * the relationship between the NODE indices and array values clearer.
**  */
** char optype[64] =
**    {
**    /* OPND     CONST    LAB      CAST     TA       IND      IFE      WHIL */ 
**       0,       0,       1,       0,       0,       0,       1,       1,
**    /* operand  operand  statemnt operand  operand  operand  statemnt statemnt */
**
**    /* DOW      SWIT     FORS     RET      GOTOS    CONT     BRK      LST2 */
**       1,       1,       1,       1,       1,       1,       1,       14,
**    /* statemnt statemnt statemnt statemnt statmnt  statemnt statemnt list
**
**    /* LST3     LST4     LST5     LST6     CAS      DFLT     CALL     TEST */
**       14,      14,      14,      14,      1,       1,       2,       3,
**    /* list     list     list     list     statemnt statemnt fncall   test
**
**    /* ADD      SUB      MUL      DIV      MOD      SHR      SHL      AND */
**       4,       4,       4,       4,       4,       5,       5,       6,
**    /* arith    arith    arith    arith    arith    shift    shift    binary */
**
**    /* OR       XOR      LOR      LAND     EQ       NE       GE       LT */
**       6,       6,       7,       7,       8,       8,       8,       8,
**    /* binary   binary   logical  logical  compare  compare  compare  compare */
**
**    /* GT       LE       NEG      NOT      COMP     PREI     PRED     POSTI */
**       8,       8,       9,       9,       9,       10,      10,      11,
**    /* compare  compare  unary    unary    unary    pre++--  pre++--  post++-- */
**
**    /* POSTD    ASGN     AADD     ASUB     AMUL     ADIV     AMOD     ASHR */
**       11,      12,      12,      12,      12,      12,      12,      12,
**    /* post++-- assign   assign   assign   assign   assign   assign   assign */
**
**    /* ASHL     AAND     AOR      AXOR     NULL     OUTASM   STMT     MOVE */
**       12,      12,      12,      12,      13,      1,       15,      16
**    /* assign   assign   assign   assign   null     statemnt linenum  structassign */
**    };
**
** char subn[64] =
**    {
**    /* OPND     CONST    LAB      CAST     TA       IND      IFE      WHIL */ 
**       0,       0,       1,       1,       1,       1,       3,       2,
**
**    /* DOW      SWIT     FORS     RET      GOTOS    CONT     BRK      LST2 */
**       2,       2,       4,       1,       1,       0,       0,       2,
**
**    /* LST3     LST4     LST5     LST6     CAS      DFLT     CALL     TEST */
**       3,       4,       5,       6,       1,       1,       2,       3,
**
**    /* ADD      SUB      MUL      DIV      MOD      SHR      SHL      AND */
**       2,       2,       2,       2,       2,       2,       2,       2,
**
**    /* OR       XOR      LOR      LAND     EQ       NE       GE       LT */
**       2,       2,       2,       2,       2,       2,       2,       2,
**
**    /* GT       LE       NEG      NOT      COMP     PREI     PRED     POSTI */
**       2,       2,       1,       1,       1,       1,       1,       1,
**
**    /* POSTD    ASGN     AADD     ASUB     AMUL     ADIV     AMOD     ASHR */
**       1,       2,       2,       2,       2,       2,       2,       2,
**
**    /* ASHL     AAND     AOR      AXOR     NULL     OUTASM   STMT     MOVE */
**       2,       2,       2,       2,       0,       0,       1,       2
**    };
**
** char commut[64] =
**    {
**    /* OPND     CONST    LAB      CAST     TA       IND      IFE      WHIL */ 
**       0,       0,       0,       0,       0,       0,       0,       0,
**
**    /* DOW      SWIT     FORS     RET      GOTOS    CONT     BRK      LST2 */
**       0,       0,       0,       0,       0,       0,       0,       0,
**
**    /* LST3     LST4     LST5     LST6     CAS      DFLT     CALL     TEST */
**       0,       0,       0,       0,       0,       0,       0,       0,
**
**    /* ADD      SUB      MUL      DIV      MOD      SHR      SHL      AND */
**       1,       0,       1,       0,       0,       0,       0,       1,
**
**    /* OR       XOR      LOR      LAND     EQ       NE       GE       LT */
**       1,       1,       0,       0,       1,       1,       1,       1,
**
**    /* GT       LE       NEG      NOT      COMP     PREI     PRED     POSTI */
**       1,       1,       0,       0,       0,       0,       0,       0,
**
**    /* POSTD    ASGN     AADD     ASUB     AMUL     ADIV     AMOD     ASHR */
**       0,       0,       0,       0,       0,       0,       0,       0,
**
**    /* ASHL     AAND     AOR      AXOR     NULL     OUTASM   STMT     MOVE */
**       0,       0,       0,       0,       0,       0,       0,       0
**    };
#endif

   tree[0] = 60;  /* nodetype NULL */
        /* any NULL nodes (i.e. if (1) ;) will point to this */

   i = 60;  /* from NULL down to CONST */
   while (--i)
      flipped[i] = i;  /* flipped is a null operation */
   flipped[38] = 41;  /* flipped of GE is LE */
      /* if you commute (a >= b), the logical equivalent is (b <= a) */
   flipped[41] = 38;  /* flipped of LE is GE */
      /* if you commute (a <= b), the logical equivalent is (b >= a) */
   flipped[40] = 39;  /* flipped of GT is LT */
      /* if you commute (a > b), the logical equivalent is (b < a) */
   flipped[39] = 40;  /* flipped of LT is GT */
      /* if you commute (a < b), the logical equivalent is (b > a) */

   wantcseg();  /* default: we are putting info into CODE seg */
   }

/* init arrays of pointers to strings */
/* Note that the pointers do not point to EOS terminated strings.  I wonder
 * if this was done deliberately to save space?
 */
initch(ptrs,chs)
   int *ptrs;
   char *chs; 
   {
   while (*chs)
      {
      *ptrs++ = chs;
      chs = chs + 6;
      }
   }

/* init arrays of pointers to strings.
 *
 * this sets the arrays at runtime instead of at compile time.  i.e.
 *    int charnames[2];
 *    initst(charnames,"FIRST SECOND ");
 * instead of something like:
 *    char *charnames[2] = { "FIRST", "SECOND" };
 * I wonder if this is because of a limitation in early compiler versions?
 */
initst(target,str)
   int  *target;
   char *str;
   {
   while (*str)
      {
      *target++ = str;  /* set pointer to current string */
      while (*str != ' ')  /* find seperating space */
         str++; 
      *str++ = 0;  /* replace space with EOS and skip it */
      }
   }




/* init arrays of BYTE values.
 *
 * this sets the arrays at runtime instead of at compile time.  i.e.
 *    char charvalues[2];
 *    initch(charvalues,"12");
 * instead of something like:
 *    char charvalues[2] = { 1, 2 };
 * I wonder if this is because of a limitation in early compiler versions?
 */
initnum(target,fromi)
   char *target,*fromi;
   {
   while (*fromi)
      {
      *target = *fromi++ - '0';
      if (*target > 9)  /* if hex digit (or G) */
         *target = *target - 7;  /* apply correction */
      target++;
      }
   }


/* get the command options. set nextpgm which is string to invoke asm88. */

/*  A   - leave .a file. do not invoke assembler.
    B   - BIG model.
    C   - checkout option.
    Dd  - d is drive from which to invoke the assembler.
    M   - Intel OMF's.
    Td  - d is the drive for temporaries.
    VE  - asks for debug information.
    VS  - asks for dump of the tree.
    X   - do not delete temporaries. do not invoke assembler.
    Z   - compile directly to object code, not assembly (DEFAULT from C88)
*/

initopt(argc,argv)
   int  argc;
   char *argv[];
   {
   char ch,*optat;
   static char dopt[4]=" DZ";
   int  narg;

   copt = 0;  /* default to no CHKOUT (not needed, is already 0) */
   strcpy(objname,argv[1]);  /* get passed filename */

#if LIMITED == 0
   for (narg = 2; narg < argc; narg++)
      {
      optat = argv[narg];

      while (ch = toupper(*optat++))
         {
         switch (ch)
            {
            case '@':
               see_addr(optat);
               *optat = 0;
               break;
            case 'A':
               aopt = 1;  /* leave .A file, do no invoke assembler */
               break;
            case 'B':  /* BIG memory model */
               nextpgm[17] = 'B';
               is_big = 1;
               break;
            case 'C':  /* add CHKOUT info */
               copt = 1;
               break;
            case 'D':  /* drive to invoke assembler from */
               nextpgm[0] =
               dopt[2] = toupper(*optat++);
               break;
            case 'M':  /* Microsoft (Intel) .OBJ format */
               nextpgm[19] = 'M';
               mopt = 1;
               break;
            case 'O':  /* .O filename */
               strcpy(objname,optat);
               while (*++optat)
                  ;
               break;
            case 'P':  /* Hmmm... end of processing? */
               *optat = 0;
               break;
            case 'T':  /* temporary file(s) drive */
               topt = toupper(*optat++);
               break;
            case 'V':  /* debugging options */
               while (*optat)
                  switch(toupper(*optat++))
                     {
                     case 'E':  /* Ve: dump debugging info */
                        aopt =  /* generate .A file, do not invoke assembler */
                        eopt =  /* dump debug info */
                        xopt = 1;  /* do not delete temporaries, do not invoke assembler */
                        break;
                     case 'S':  /* Vs: display tree */
                        aopt =  /* generate .A file, do not invoke assembler */
                        sopt =  /* display tree */
                        xopt = 1;  /* do not delete temporaries, do not invoke assembler */
                        break;
                      }
               break;
            case 'X':
               aopt =  /* generate .A file, do not invoke assembler */
               xopt = 1;  /* do not delete temporaries, do not invoke assembler */
               break;
            case 'Z':
               zopt = 1;  /* generate .O file directly */
            }
         }
      }
#endif

   /* create invocation line for assembler. */

   if (topt)
      nextpgm[8] = topt;  /* if we have drive, set it */
   else
      nextpgm[8] =
      nextpgm[9] = ' ';  /* else erase <drive>: */

   strcpy(asmname,objname);  /* object name is also assembly name */
   strcat(objname,".O");
   strcat(nextpgm,objname);  /* pass filename to ASM88 (if used) */
   if (copt)
      strcat(nextpgm," C");  /* if CHKOUT, tell ASM88 too */
   if (dopt[2] != 'Z')  /* if assembler drive given */
      strcat(nextpgm,dopt);  /* pass that to ASM88 */
   strcat(asmname,".A");

   /* set asmname to name of output file */

   if (aopt == 0)  /* if not generating .A file */
       {
      if (topt)  /* if temp drive given */
         {
         asmname[0] = topt;
         asmname[1] = ':';
         asmname[2] = 0;
         }
      else
         asmname[0] = 0;
      strcat(asmname,"CTEMP4");  /* pass tempname to ASM88 */
      }
   }

/* end of control file, time to quit program */
endit()
   {
   int  i;
   unsigned util1,warn;
   char chr,*intname;

   if (eopt)  /* Ve: display debug info */
      olf();
   warn = ctlword();  /* number of warnings */
   util1 = ctlword();  /* utilization from C88 */
   if (util1 > util)  /* if C88 utilization > our utiliziation, pass that on */
      util = util1;
   if (zopt)  /* if generating .O file directly */
      asm_endit();  /* cleanup & finish .O */
   else
      os(" END\n");  /* finish .A file */
   close(treef);  /* close control files  */
   close(control);

/* get rid of temporaties CTEMP1 and CTEMP2 */

   intname = "A:CTEMP1";
   if (topt)
      *intname = topt;  /* if temp drive given, use it */
   else
      intname += 2;  /* else skip "A:" */

   if (eopt == 0)  /* not Ve (Ve == do not delete temporaries) */
      {
      /* get rid of temporaties CTEMP1 and CTEMP2 */

      intname = "A:CTEMP1";  /* we already have intname, why do this again? */
      if (topt)
         *intname = topt;
      else
         intname += 2;
      if (unlink(intname) == -1)
         error("Cannot Unlink CTEMP1");

      intname = "A:CTEMP2";
      if (topt)
         *intname = topt;  /* if temp drive given, use it */
      else
         intname += 2;  /* else skip "A:" */

      if (unlink(intname) == -1)
         error("Cannot Unlink CTEMP2");
      if (zopt == 0)  /* generating .A file */
         {
         if (write(output,outbuf,inout-outbuf) == -1)
            error("Cannot Write .A");
         if (close(output) == -1)
            error("Cannot Close .A");
         }
      }
   if (nextlab >= lastlab)
      error("too many internal labels");
   util1 = (nextlab - 1000) / (1000 / 100);  /* label utilization */
   if (util1 > util)
      util = util1;
   util1 = numext / (EXTATMAX / 100);  /* external utilization */
   if (util1 > util)
      util = util1;
   util1 = (nextext - ext) / (EXTMAX / 100);  /* external utilization */
   if (util1 > util)
      util = util1;
   inout = 0;  /* clear ptr into outbuf[] */
   if (warn && see_exit == 0)
      {
      os(" Number of Warnings = ");
      ounum(warn);
      os("\n");
      strcat(nextpgm," Z");
      }

/* if a option is off, trigger assembler. the Cnn option supplies the
   current %utilization number. */


   if (aopt == 0 && zopt == 0)  /* not compiling to .A and not generating .O directly */
      {
      nextpgm[22] += util / 10;
      nextpgm[23] += util % 10;
      if (nextpgm[0] != 'Z')  /* if drive given */
         _chain(nextpgm);   /* execute asm88 */
      else
         _chain(&nextpgm[2]);
      }
   os("End of C88     ");
   if (zopt)  /* if generating .O file directly */
      asm_size();  /* show code/data sizes */
   os("     ");
   ounum(util);
   os("% Utilization    ");
   if (mopt && zopt)
      {
      if (nextpgm[0] != 'Z')
         _chain(nextpgm);   /* execute toobj */
      else
         _chain(&nextpgm[2]);
      }
   real_exit(warn ? 1 : 0);
   }

/* generate a function from a tree */
addfun()
   {
   unsigned tutil,fline;
   int  i,old_lab,old_last;

   funord = ctlword();  /* index of function name in symbol table */
   treelen = ctlword();  /* number of nodes in function tree */
   pstart = ctlword();  /* root node to start processing tree */
   pbytes = ctlword();  /* passed bytes to function */
   curoff =
   locoff = -ctlword();  /* number of bytes to allocate to locals */
   fline = ctlword();  /* line number of function (CHKOUT files) */
#if DEBUG
   if (eopt)
      {
      oc(' ');
      oname(funord);
      os(" size ");
      odword(treelen);
      os (" start ");
      odword(pstart);
      os(" parms ");
      odword(pbytes);
      os(" locals ");
      odword(locoff);
      olf();
      }
#endif
   if (treelen >= TREEMAX)  /* do we have enough room for tree? */
      error("function too big");
   tutil = treelen / (TREEMAX / 100);  /* usage percentage */
   if (tutil > util)  /* if above current high */
      util = tutil;  /* set new usage percent */
   while (nodesin < treelen)  /* read tree */
      tree[++nodesin] = treeword();

#if OPT
   down = 0;
   for (i = 0; i < NUMREC; i++)  /* register tracking init */
      recat[i] =
      recent[i] = 0;
#endif

   reorder(pstart);  /* switch nodes around for better code */
#if OPT
   candidate(pstart);
   down = 0;
#endif

#if DEBUG
   if (sopt)
      {
      level = 0;
      listnode(pstart);
      }
#endif
   wantcseg();  /* make sure code winds up in CS */
   if (fline)  /* if chkout info */
      {
      asm_line(fline);  /* add it to .O/.A file */
      }

#if OPT
   /* keep trying code generation until no improvement results */
   better =
   perfect = 0;
   do {
      better = 0;
      old_lab = nextlab;
      old_last = lastlab;
      down = 0;
      genfun();
      nextlab = old_lab;
      lastlab = old_last;
      } while (better);
   perfect = 1;
   down = 0;
#endif
   genfun();
   }

#if DEBUG
listnode(node)
   int  node;
   {
   char i,*name,type,ch;
   int  j,k;

   type = tree[node];
   if (level < 30)
      i = level + level + 1;
   else
      i = 61;
   while (--i)
      oc(' ');
   odword(node);
   oc(' ');
   i = 7;
   name = namen[type];
   while (--i)
      oc(*name++);
   i = tree[node] >> 8;
   if (i)
      {
      oc(' ');
      obyte(i);
      oc(' ');
      }
   else
      os("   ");
   if (type <= CONST)
      {
      onum(tree[node+1]);
      oc(' ');
      }
   if (type == OPND || type == LAB || type == CAS ||
                             (type >= PREI && type <= POSTD))
         onum(tree[node+2]);
   if (type == OPND)
      {
      oc(' ');
      obyte(tree[node+3] >> 8);
      oc(' ');
      i = tree[node+3];
      onum(i);
      }
   k = 0;
   switch (type)
      {
      case WHIL:
      case DOW:
         k = 3;
         break;
      case FORS:
         k = 5;
      }
   if (k)
      {
      for (j = k; j < k+3; j++)
         {
         oc(' ');
         onum(tree[node+j]);
         }
      }

   olf();
   i = subn[type];
   if (i==0)
      return;
   level++;
   while (i--)
      listnode(tree[++node]);
   level--;
   }
#endif


addext(nested)
   char nested;
   {
   char extst, ch, typ, slen, i, *bptr, xstring;
   int  thisext, vtype[7], oldnode;
   unsigned len, index;
   union
      {
      double dbl;
      float flt;
      unsigned flts[2];
      long lng;
      } cvt;

   extst = ctlbyte();  /* get visibility */
   asmext =
   thisext =
   numext = ctlword();  /* get entry number / BP offset */
   if (numext >= EXTATMAX-1 || nextext >= &ext[EXTMAX-40])
        /* number or no space left in ext[] */
      error("too many externals");
   extat[numext] = nextext;  /* save ptr to attribute (visibility) & name */
   *nextext++ = extst;   /* need the attribute byte too */
   do
      {
      ch = ctlbyte();  /* get symbol name */
      *nextext++ = ch;
      } while (ch);

   if ((extst & 0x7f) == SEXTONLY)  /* extern declaration i.e. extern int i; */
      {
      if (extst >= 128)  /* large memory model */
         wanteseg();
      else
         wantdseg();
      asm_public(numext,extat[numext]+1,1);  /* declare public for BIND */
      ch = INITFUN;  /* skip rest of this routine */
      }
   else
      ch = ctlbyte();  /* get init info */
   if ((extst & 0x7f) == SEXTERN)  /* variable declare i.e. int i; */
      {
      if (ch == INITFUN)  /* a function, make sure we are in right seg */
         wantcseg();
      else
         {
         if (extst >= 128)  /* large memory model */
            wanteseg();
         else
            wantdseg();
         }
      asm_public(numext,extat[numext]+1,1);  /* declare public for BIND */
      }
   if (zopt && copt && (extst & 0x7f) == SSTATIC)
              /* why no STATIC if going to assembly? */
      asm_static(numext,extat[numext]+1);
   if (ch != INITFUN)
      {
      findstr(ch);  /* check format of variable init in CTEMP1 control file */
      if (extst >= 128)  /* large memory model */
         wanteseg();
      else
         wantdseg();
      if (zopt == 0)  /* generating .A file */
         oname(thisext);
      while (ch != INITEND)  /* init variables */
         {
         if (zopt)  /* if generating .O file directly */
            test_flush(300);
         switch (ch)
            {
            case 1:  /* nested string init */
               ctlbyte();  /* skip nested string init */
                           /* skip visibility */
               ctlword();  /* skip ordinal */
               if (ctlbyte() != 0)  /* name != NULL, not unlabeled string */
                  ierror();  /* does not return */
               if (ctlbyte() != INITSTR)  /* not a string init */
                  ierror();  /* does not return */
               do
                  {
                  slen = ctlbyte();  /* get string len */
                  while (slen--)  /* skip string */
                     ctlbyte();
                  } while (ctlbyte() != 0xFF);  /* until EOF */
               if (ctlbyte() != INITEND)  /* not end of string, oops! */
                  ierror();  /* does not return */
               ch = ctlbyte();  /* get next init */
               break;
            case INITDB:  /* reserve bytes, 0 initialization */
                  /* NOTE: it takes a statement like
                   *          char a[4] = ;
                   *       to generate a INITDB record.
                   */
               len = ctlword();  /* get bytes to reserve */
               if (zopt)  /* if generating .O file directly */
                  test_flush(len);
               for (index = 0; index < len; index++)
                  {
                  if ((index % 10) == 0)
                     {
                     if (index && zopt == 0)  /* generating .A file */
                        olf();
                     if (zopt)  /* if generating .O file directly */
                        test_flush(300);
                     asm_db();
                     }
                  else
                     if (zopt == 0)  /* generating .A file */
                        oc(',');
                  if (zopt)  /* if generating .O file directly */
                     codeb(0);
                  else
                     oc('0');
                  }
               if (zopt == 0)  /* generating .A file */
                  olf();
               ch = ctlbyte();
               break;
            case INITRB:  /* reserve data space */
               len = ctlword();  /* get len */
               asm_rb(len,thisext);  /* reserve bytes, thisext is for .O file */
               ch = INITEND;  /* force end of init */
               break;
            case INITVAL:  /* init of a static inside a function */
               typ = ctlbyte();  /* get type */
               oldnode = ctlword();  /* re-use space for values */
                                    /* where to truncate tree to remove init value */
               index = ctlword();  /* get "highwater" node */
               while (nodesin < index)  /* read nodes */
                  tree[++nodesin] = treeword();
                       /* BUG: it may be minor, since we have TREEMAX (8000)
                        *      nodes available, but we should check for
                        *      overflow...
                        */
               index = ctlword();  /* get starting node */
#if DEBUG
               if (sopt)
                  {
                  level = 0;
                  listnode(index);
                  }
#endif
               getval(index,vtype);  /* get value of tree */
               nodesin = oldnode;   /* chop off value expression */

               switch (typ)
                  {
                  case CSCHAR:
                  case CCHAR:
                     if (vtype[VIS] != CONSTV)
                        ierror();  /* does not return */
                     else
                        {
                        forceint(vtype);  /* take care of type conversion */
                        asm_db();
                        if (zopt)  /* if generating .O file directly */
                           codeb(vtype[VVAL]);
                        else
                           {
                           odbyte(vtype[VVAL] & 255);
                           olf();
                           }
                        }
                     break;
                  case CINT:
                  case CUNSG:
                     if (vtype[VIS] != CONSTV && vtype[VIS] != OFFV)
                            /* sizeof(constv) == sizeof(offv), implied small memory model */
                        ierror();  /* does not return */
                     else
                        {
                        forceint(vtype);  /* take care of type conversion */
                        if (vtype[VIS] == OFFV)
                           vtype[VIS] = VARV;
                        asm_dw();
                        vtype[VT] = typ;
                        if (zopt)  /* if generating .O file directly */
                           asm_const(vtype,CINT);
                        else
                           {
                           orm(vtype);
                           olf();
                           }
                        }
                     break;
                  case CLONG:
                     if (vtype[VIS] != CONSTV)
                        ierror();  /* does not return */
                     else
                        {
                        forcel(vtype);
                        asm_dd();
                        if (zopt)  /* if generating .O file directly */
                           {
                           codew(vtype[VVAL]);
                           codew(vtype[VVAL + 1]);
                           }
                        else
                           {
                           olong(&vtype[VVAL]);
                           olf();
                           }
                        }
                     break;
                  case CFLOAT:
                     if (vtype[VIS] != CONSTV)
                        ierror();  /* does not return */
                     if (vtype[VT] == CDOUBLE)
                        cvt.flt = ((char *)(&vtype[VVAL]))->dbl;
                     else
                        if (vtype[VT] == CLONG)
                           cvt.flt = ((char *)(&vtype[VVAL]))->lng;
                        else
                           cvt.flt = vtype[VVAL];
                     asm_dw();
                     if (zopt)  /* if generating .O file directly */
                        {
                        codew(cvt.flts[0]);
                        codew(cvt.flts[1]);
                        }
                     else
                        {
                        oword(cvt.flts[0]);
                        ocomma();
                        oword(cvt.flts[1]);
                        olf();
                        }
                     break;
                  case CDOUBLE:
                     if (vtype[VIS] != CONSTV)
                        ierror();  /* does not return */
                     forcef(vtype);
                     asm_dw();
                     if (zopt)  /* if generating .O file directly */
                        {
                        codew(vtype[VVAL]);
                        codew(vtype[VNAME]);
                        codew(vtype[VOFF]);
                        codew(vtype[VMORE]);
                        }
                     else
                        {
                        oword(vtype[VVAL]);
                        ocomma();
                        oword(vtype[VNAME]);
                        ocomma();
                        oword(vtype[VOFF]);
                        ocomma();
                        oword(vtype[VMORE]);
                        olf();
                        }
                     break;
                  case PTRTO:
                     if (vtype[VIS] == CONSTV)
                        {
                        forcel(vtype);
                        asm_dd();
                        if (zopt)  /* if generating .O file directly */
                           {
                           codew(vtype[VVAL]);
                           codew(vtype[VVAL+1]);
                           }
                        else {
                           olong(&vtype[VVAL]);
                           olf();
                           }
                        }
                     else
                        if (vtype[VIS] == OFFV)
                           {
                           vtype[VIS] = VARV;
                           asm_dd();
                           if (zopt)  /* if generating .O file directly */
                              asm_ptr(vtype);
                           else
                              {
                              vtype[VT]=typ;
                              oddrm(vtype);
                              olf();
                              }
                           }
                        else
                           ierror();  /* does not return */
                     break;
                  default:
                     ierror();  /* does not return */
                  }
               ch = ctlbyte();
               break;
concatstring:
            case INITSTR:
               asm_db();
               slen = ctlbyte();  /* get string len */
               len = 0;  /* 
   /* i = 0 no output yet. i = 1 number output last. i = 2 character last. */
               i = 0;
               while (slen--)
                  {
                  ch = ctlbyte();  /* get string byte */
                  if (zopt)  /* if generating .O file directly */
                     codeb(ch);
                  else
                     {
                     if (ch < ' ' || ch == '\47' || ch == '\\'|| ch >= 126)
                                       /* '\47' == single quote */
                            /* non-printable char, init via value */
                        {
                        if (i == 2)  /* character last, output a quote */
                           oc('\47');
                        if (i)  /* number or character last */
                           {
                           if (len > 40)  /* too long for this line */
                              {
                              olf();
                              asm_db();
                              len =
                              i = 0;
                              }
                           else
                              oc(',');
                           }
                        onum(ch);  /* output as a number */
                        len += 5;  /* len of number */
                        i = 1;  /* just output a number */
                        }
                     else  /* printable */
                        {
                        if (i == 1)  /* last was a number */
                           oc(',');  /* separate with a comma */
                        if (i != 2)  /* if last was not a char */
                           oc('\47');  /* output a single quote */
                        oc(ch);
                        len++;
                        if (len > 60)  /* line too long */
                           {
                           os("'\n DB ");  /* finish this line, start new one */
                           i =  /* no output yet  */
                           len = 0;
                           }
                        else
                            i = 2;  /* output a char last */
                        }
                     }
                  }
               if (ctlbyte() != 0xFF)  /* if not EOS */
                  {
                  if (zopt == 0)  /* generating .A file */
                     {
                     if (i == 2)  /* if last was a char */
                        oc('\'');  /* ending quote */
                     olf();
                     }
                  goto concatstring;  /* do next piece */
                  }
               if (zopt)  /* if generating .O file directly */
                  codeb(0);   /* end the string */
               else
                  {
                  switch (i)
                     {
                     case 0:
                        oc('0');   /* null string */
                        break;
                     case 1:
                        os(",0");   /* number last */
                        break;
                     case 2:
                        os("',0");   /* char last */
                     }
                  olf();
                  }
               if (nested)  /* string constant via findstr() */
                  return;
               ch = ctlbyte();
            }
         }
      }
#if DEBUG
   if (eopt)
      {
      oc(' ');
      oname(numext);
      olf();
      }
#endif
   }

/* check format of variable init in CTEMP1 control file */
findstr(itype)
   char itype;
   {
   char slen;
   int  oldblk, oldin, oldext;

   oldblk = ctlblk;  /* set up to "unparse" CTEMP1 control file */
   oldin = inctl;
   while (itype != INITEND)  /* until end of init data */
      {
      switch (itype)
         {
         case 1:   /* Variable declaration, probably a constant string */
            oldext = asmext;
            addext(1);   /* go back and look for strings */
            if (ctlbyte() != INITEND)
               ierror();  /* does not return */
            itype = ctlbyte();  /* get next piece */
            asmext = oldext;
            break;
         case INITDB:  /* reserve bytes */
            ctlword(); /* skip length */
            itype = ctlbyte();  /* get next control byte */
            break;
         case INITRB:
            ctlword(); /* skip length */
            itype = INITEND;  /* and that's all for this init */
            break;
         case INITVAL:  /* constant init value */
            ctlbyte();  /* skip type */
            ctlword();  /* skip "node to keep" */
            ctlword();  /* skip num_nodes */
            ctlword();  /* skip start_node */
            itype = ctlbyte();  /* next control byte */
            break;
         case INITSTR:  /* string has more complex parsing */
            do
               {
               slen = ctlbyte();  /* get length */
               while (slen--)  /* skip string  */
                  ctlbyte();
               } while(ctlbyte() != 0xFF);  /* until EOS marker */
            itype = ctlbyte();  /* get next control byte */
            break;
         default:
            ierror();  /* does not return */
         }
      }
   if (oldblk != ctlblk)  /* backtracking in CTEMP1 */
      {
      if (lseek(control,((long)oldblk)*BUFSIZE,0) == -1)
         error("Cannot Seek CTEMP1");
      if (read(control,ctlbuf,BUFSIZE) == -1)
         error("Cannot Read CTEMP1");
      ctlblk = oldblk;
      }
   inctl = oldin;  /* finish backtracking CTEMP1 */
   }

/* does not return */
ierror()
   {
   inout = 0;
   if (line_num)
      {
      os("in line ");
      onum(line_num);
      os("  ");
      }
   os("illegal initialization for ");
   oname(numext);
   olf();
   real_exit(2);
   }

ctlbyte()
   {
   if (inctl == &ctlbuf[BUFSIZE])  /* if end of buffer */
      {
      if (read(control,ctlbuf,BUFSIZE) == -1)
         error("Cannot Read CTEMP1");
      inctl = ctlbuf;
      ctlblk++;  /* for "unparsing" in findstr() */
      }
   return *inctl++;  /* get next byte of buffer */
   }

ctlword()
   {
   char ch;

   ch = ctlbyte();
   return (ch + (ctlbyte() << 8));
   }

treeword()
   {
   if (intree == &treebuf[BUFSIZE])
      {
      if (read(treef,treebuf,BUFSIZE) == -1)
         error("Cannot Read CTEMP2");
      intree = treebuf;
      }
   return *intree++;
   }


/* OC  -- output a .a character */

oc(ch)
   char ch;
   {
#if OPT
   if (perfect || xopt)
      {
#endif
      if (ch == LF)
         oc(CR);
      if (inout)
         {
         if (inout == &outbuf[BUFSIZE])
            {
            if (write(output,outbuf,BUFSIZE) == -1)
               error("Cannot Write .A");
            inout = outbuf;
            }
         *inout++ = ch;
         }
      else
         {
         if (see_exit)
            {
            if (see_index < 78 && ch != '\n')
               see_msg[see_index++] = ch;
            }
         else
            putchar(ch);
         }
#if OPT
      }
#endif
   }

os(str)
   char *str;
   {
   while (*str)
      oc(*str++);
   }

obyte(ch)
   char ch;
   {
   char hexb;

   hexb = ch >> 4;
   if (hexb > 9)
      oc(hexb + 55);
   else
      oc(hexb + '0');
   hexb = ch & 15;
   if (hexb > 9)
      oc(hexb + 55);
   else
      oc(hexb + '0');
   }

oword(word)
   int word;
   {
   if (word & 0x8000)
      oc('0');
   obyte(word >> 8);
   obyte(word);
   oc('H');
   }

error(estr)
   char *estr;
   {
   inout = 0;
   olf();
   os("pass 2 error ");
   if (line_num)
      {
      os("in line ");
      onum(line_num);
      os("  ");
      }
   os(estr);
   olf();
   if (zopt)  /* if generating .O file directly */
      asm_error();
   real_exit(2);
   }

odbyte(ch)
   char ch;
   {
   char i, divisor, signif;

   signif = 0;
   divisor = 100;
   while (divisor)
      {
      if (divisor == 1)
         signif = 1;
      if (i = ch / divisor)
         {
         oc(i + '0');
         signif = 1;
         }
      else
         if (signif)
            oc('0');
         else
            oc(' ');
      ch = ch % divisor;
      divisor = divisor / 10;
      }
   }

odword(word)
   int word;
   {
   int i, divisor;
   char signif;

   signif = 0;
   if (word < 0)
      {
      word = -word;
      oc('-');
      }
   divisor = 10000;
   while (divisor)
      {
      if (divisor == 1)
         signif = 1;
      if (i = word / divisor)
         {
         oc(i + '0');
         signif = 1;
         }
      else
         if (signif)
            oc('0');
         else
            oc(' ');
      word = word % divisor;
      divisor = divisor / 10;
      }
   }

onum(word)
   int word;
   {
   if (word < 0)
      {
      if (word == 0x8000)
         {
         os("-32768");
         return;
         }
      oc('-');
      word = -word;
      }
   if (word >= 10)
      onum(word / 10);
   oc(word % 10 +'0');
   }

ouunum(word)
   unsigned word;
   {
   if (word >= 10)
      ouunum(word / 10);
   oc(word % 10 + '0');
   }

/* Hmmm... ouunum() and ounum() are identical... */
ounum(word)
   unsigned word;
   {
   if (word >= 10)
      ounum(word / 10);
   oc(word % 10 + '0');
   }

olong(lnum)
   char *lnum;
   {
   oc('0');
   obyte(*(lnum+3));
   obyte(*(lnum+2));
   obyte(*(lnum+1));
   obyte(*lnum);
   oc('H');
   }


/* stuff for SEE interface. */


see_addr(ptr)
   char *ptr;
   {
   see_exit = 1;
   see_seg = see_hex(&ptr);
   see_off = see_hex(&ptr);
   }

see_hex(ptrptr)
   char **ptrptr;
   {
   char *ptr, ch;
   int  num;

   ptr = *ptrptr;
   num = 0;
   while (1)
      {
      ch = *ptr++;
      if (ch >= '0' && ch <= '9')
         num = num * 16 + ch - '0';
      else
         if (ch >= 'a' && ch <= 'f')
            num = num * 16 + ch - 'a' + 10;
         else
            if (ch >= 'A' && ch <= 'F')
               num = num * 16 + ch - 'A' + 10;
            else
               {
               *ptrptr = ptr;
               return num;
               }
      }
   }

/* SEE_CALL -- SEE interface routine. */

see_call(p1,p2,p3)
   int p1, p2, p3;
   {
#asm
   pop    word see_bp_
   pop    word see_ret_
   lcall  dword see_off_
   push   word see_ret_
   push   word see_bp_
#endasm
   }

/* REAL_EXIT -- do an exit or a return to SEE. */

real_exit(cc)
   int cc;
   {
   if (see_exit)
      {
      see_call(2);
      if (cc)
         {
         if (copt)
            unlink(objname);
         see_call(-1,see_msg,line_num ? line_num : 1);
         }
      }
   exit(cc);
   }


/* get value of a subtree */
/* recursive subroutine */
/* recursive via many indirect paths */
getval(node,vtype)
   int  node, vtype[];
   {
   int  lastnode;
   char type, otype;

   type = tree[node];
   otype = optype[type];
#if DEBUG
   if (eopt)
      {
      os("node ");
      onum(node);
      os(" type ");
      onum(type);
      os(" otype ");
      onum(otype);
      olf();
      }
#endif
   vtype[VMORE] = -1;  /* default seg */
   switch (otype)
      {
      case 0:  /* operand, CAST, TA, IND */
         genopnd(node,vtype);
         break;
      case 2:  /* function call */
         genfcal(node,vtype);
         break;
      case 3:  /* test */  /* conditional:  ? : */
         gentest(node,vtype);
         break;
      case 4:  /* arithmetic */
         genarith(node,vtype);
         break;
      case 5:  /* shift */
         genshift(node,vtype);
         break;
      case 6:  /* binary */
         genbin(node,vtype);
         break;
      case 7:  /* logical */
         genlog(node,vtype);
         break;
      case 8:  /* comparison */
         gencmp(node,vtype);
         break;
      case 9:  /* unary */
         genunary(node,vtype);
         break;
      case 10:  /* pre ++ or -- */
         genpre(node,vtype);
         break;
      case 11:  /* post ++ or -- */
         genpost(node,vtype);
         break;
      case 12:  /* assignment */
         genasgn(node,vtype);
         break;
      case 14:  /* LIST of nodes */
         lastnode = node + type - LST;
         while (++node < lastnode)
            getnoval(tree[node],vtype);
         getval(tree[node],vtype);
         break;
      case 16:  /* structure assignment */
         genmove(node,vtype);
            /* reload the source value as result */
         nopost = 1;
         nopre = 1;
         getval(tree[tree[node+2]+1],vtype);
         nopost = 0;
         nopre = 0;
         break;
      default:  /* 1 == statement, 13 == NULL, 15 == line number */
         error("bad expression");
      }
   }

/* recursive via getval() */
genopnd(node,vtype)
   int node, vtype[];
   {
   int nnode, vright[7];
   char type, dtype, reg;

   dtype = tree[node] >> 8;  /* type of node (CINT, etc) */
   type = tree[node];  /* type of operand */
#if OPT
   vtype[VFROM] = 0;
#endif
   switch (type)
      {
      case OPND:
         vtype[VNAME] = tree[node + 1];
         vtype[VOFF] = tree[node + 2];
         vtype[VMORE] = -1;  /* default seg */
         if (vtype[VNAME])  /* if named, it is in data seg */
            {
            vtype[VVAL] = 8;  /* 8 -> name[value] addressing */
            if (is_big)
               {
               if (*extat[vtype[VNAME]] < 128)
                  vtype[VMORE] = DS;
               else
                  vtype[VMORE] = NEED_ES;
               }
            }
         else
            {
            vtype[VVAL] = 6;  /* 6 -> [BP+value] */
            if (is_big)
               vtype[VMORE] = SS;
            }
         vtype[VT] = dtype;
         if ((dtype == ARRAY) || (dtype == FUNCTION))  /* pointer to */
            {
            vtype[VIS] = OFFV;  /* get offset */
            vtype[VT] = is_big ? PTRTO : CUNSG;  /* small memory model: unsigned int */
            if (dtype == FUNCTION && is_big)
               {
               if (*extat[vtype[VNAME]] == SSTATIC)  /* local to source module */
                  vtype[VMORE] = CS;
               else
                  vtype[VMORE] = NEED_ES;
               }
            }
         else
            {
            vtype[VIS] = VARV;  /* variable reference */
#if OPT
            down++;
            /* remember the location of type word */
            if (tree[node+3])
               {
               vtype[VFROM] = node;
               if (isasgn == 0 && is_reg(vtype) == 0)
                  {
                  if ((reg = want_reg(tree[node+3]+down+20,dtype == CCHAR)) != -1)
                     {
                     movreg(reg,vtype);
                     reg_from[reg] = node;
                     reg_dirty[reg] = 0;
                     }
                  }
               }
#endif
            }
         break;

      case CONST:
         vtype[VIS] = CONSTV;
         vtype[VVAL] = tree[node + 1];
         vtype[VNAME] = 0;  /* high word of value */
         if (dtype == CLONG)  /* 32-bit value */
            vtype[VNAME] = tree[node + 2];
         else
            if (dtype == CDOUBLE)  /* 64-bit value (float constants are DOUBLES) */
            {
            vtype[VNAME] = tree[node + 2];
            vtype[VOFF] = tree[node + 3];
            vtype[VMORE] = tree[node + 4];
            }
         vtype[VT] = dtype;
         break;
      case CAST:
         if ((dtype == CINT || dtype == CUNSG)
                 && (tree[tree[node+1]] == (CLONG << 8)+OPND
                               || tree[tree[node+1]] == (PTRTO << 8)+OPND))
                   /* main() { int a; long b; a = (int)b; } */
            tree[tree[node+1]] = (CUNSG << 8) + OPND;
               /* if the cast won't do anything, don't bother with the long access */
         getval(tree[node+1],vtype);  /* get value of tree */
         switch (dtype)
            {
            case CSCHAR:
            case CCHAR:
               forcebyt(vtype);  /* force "byte" type */
               break;
            case CLONG:
               forcel(vtype);  /* force long type */
               break;
            case CFLOAT:
               {
               union
                  {
                  float flt;
                  double dbl;
                  long lng;
                  };
   /* DeSmet-ism:  this will be used in the format ptr->flt
    *              without properly typecasting the pointer.
    */
               if (vtype[VIS] == CONSTV)  /* constant */
                  {
                  if (vtype[VT] == CDOUBLE)  /* cast DOUBLE to FLOAT */
                     ((char *)(&vtype[VVAL]))->flt = ((char *)(&vtype[VVAL]))->dbl;
                  else
                     if (vtype[VT] == CLONG)  /* cast LONG to FLOAT */
                        ((char *)(&vtype[VVAL]))->flt = ((char *)(&vtype[VVAL]))->lng;
                     else
                        ((char *)(&vtype[VVAL]))->flt = vtype[VVAL];  /* cast INT to FLOAT */
                  vtype[VT] = CFLOAT;
                  }
               else
                  loadf(vtype);  /* put number on FP stack */
               }
               break;
            case CDOUBLE:
               forcef(vtype);  /* put number on FP stack */
               break;
            case CSTRUCT:
               if (vtype[VT] == CLONG)
                  forceint(vtype);  /* take care of type conversion */
               vtype[VT] = CSTRUCT;
               break;
            case FUNCTION:
            case PTRTO:
               if (vtype[VT] != PTRTO)
                  forcel(vtype);   /* ?? vtype[VT] = PTRTO; ?? */
               break;
            default:
               forceint(vtype);  /* take care of type conversion */
               if (dtype != CINT)  /* everything that is not an INT is unsigned */
                  vtype[VT] = CUNSG;
               else
                  vtype[VT] = CINT;
            }
         break;
      case TA:
         getval(tree[node+1],vtype);  /* get value of tree */
         if (vtype[VIS] == VARV)  /* if a variable */
            {
            vtype[VIS] = OFFV;  /* get offset of */
            if (vtype[VNAME] == 0 && vtype[VOFF] == 0)  /* if simple local */
               {
               if (vtype[VVAL] == 4)  /* 4 -> name[SI+value] */
                  {
                  vtype[VVAL] = SI;  /* just register SI */
                  vtype[VIS] = REGV;  /* register variable */
                  }
               else
                  if (vtype[VVAL] == 5)  /* 5 -> name[DI+value] */
                     {
                     vtype[VVAL] = DI;  /* just register DI */
                     vtype[VIS] = REGV;  /* register variable */
                     }
               }
            }
         else
            if (vtype[VT] != CSTRUCT)  /* not STRUCT or UNION */
               error("cannot address");
         vtype[VT] = is_big ? PTRTO : CUNSG;  /* small model, this is UNSIGNED */
         break;
      case IND:  /* indirect */
         nnode = tree[node+1];

/* if an add then use an addressing register. */

         prefer_si = 1;  /* would rather use SI in case index */
         if (tree[nnode] == ADD)
            {
            getval(tree[nnode+2],vright);  /* get value of right tree */
            getval(tree[nnode+1],vtype);  /* get value of left tree */
            prefer_si = 0;

/* ADD has better code for offsets */

            if (vtype[VIS] == OFFV || vright[VIS] == OFFV)
               {
               genadd(vtype,vright);
               }
            else
               {
               if (vright[VT] == PTRTO)
                  flip(vtype,vright);  /* swap lnode, vtype references and contents */
               forceind(vtype);
               vtype[VNAME] =
               vtype[VOFF] = 0;
               if (vright[VIS] == CONSTV)
                  vtype[VOFF] = vright[VVAL];
               else
                  {
                  forceint(vright);  /* take care of type conversion */
                  forcerm(vright);
                  if (is_big)
                     forcees(vright);
                  asm_add(ADD86,vtype,vright);
                  freev(vright);
                  forceind(vtype);
                  }
               if (vtype[VVAL] == SI)
                  vtype[VVAL] = 4;  /* 4 -> name[SI+value] */
               else
                  vtype[VVAL] = 5;  /* 5 -> name[DI+value] */
               }
            }
         else
            {
            getval(tree[node+1],vtype);
            prefer_si = 0;
            if (vtype[VIS] != OFFV)
               {
               forceind(vtype);
               if (vtype[VVAL] == SI)
                  vtype[VVAL] = 4;  /* 4 -> name[SI+value] */
               else
                  vtype[VVAL] = 5;  /* 5 -> name[DI+value] */
               vtype[VNAME] =
               vtype[VOFF] = 0;
               }
            }
         vtype[VIS] = VARV;
         vtype[VT] = dtype;
        }
   }
